
export function InjectEmptyExports(babel) {
    const stub = babel.template("export { }")();
    return {
        visitor: {
            Program(root, state) {
                const filename = state.filename.split("\\").join("/");
                if (filename.endsWith(".d.ts"))
                    return;
                if (filename.includes("/node_modules/"))
                    return;

                let empty = true;
                root.traverse({
                    ExportDeclaration(path) {
                        if (empty)
                            empty = isTypeDeclaration(path.node);
                    },
                });

                if (empty)
                    root.node.body.push(stub);
            },
        },
    };
}
function isTypeDeclaration(node) {
    if (node.type === "ExportNamedDeclaration")
        if (node.declaration)
            switch (node.declaration.type) {
                case "TSTypeAliasDeclaration":
                case "TSInterfaceDeclaration":
                    return true;
            }
}
//# sourceMappingURL=inject-empty-exports.js.map
