import { TransformOptions } from "@babel/core";
import { WebpackConfigurer, WebpackContext } from "@webpackery/core";
import { RuleSetCondition, RuleSetRule } from "webpack";
export declare namespace BabelConfigurer {
    interface Props extends RuleSetRule {
        /**
         * @see RuleSetRule#test.
         * @default regex from {@link extensions}.
         */
        test?: RuleSetCondition;
        /** Babel loader options. */
        options?: TransformOptions;
        /**
         * Extensions to register for webpack resolution.
         * @default
         * - includes `.ts` when `@babel/preset-typescript` preset
         * - includes `.[jt]sx` when `@babel/react` preset
         */
        extensions?: string[];
        /**
         * Whether to process React files.
         * Enabled by default when any React related plugin detected.
         */
        useReact?: boolean;
        /**
         * Whether to process TypeScript files.
         * Enabled by default when any TypeScript related plugin detected.
         */
        useTypesScript?: boolean;
        /**
         * Path to a tsconfig.json.
         * May define additional properties to use in babel / webpack.
         */
        tsconfigPath?: string;
    }
}
export declare class BabelConfigurer extends WebpackConfigurer<BabelConfigurer.Props> {
    /** @inheritdoc */
    protected prepare(props: BabelConfigurer.Props, context: WebpackContext): BabelConfigurer.Props;
    /** @inheritdoc */
    protected configure(context: WebpackContext, props: BabelConfigurer.Props): void;
}
//# sourceMappingURL=babel-configurer.d.ts.map