import { CompilerOptions, Diagnostic, FormatDiagnosticsHost, ParsedCommandLine, PrinterOptions, System } from "typescript";
/**
 * TypeScript library type definitions, including some internal methods.
 * Defines return types for some methods as some editors (intelliJ IDEA) struggles to resolve it itself.
 */
export declare type TypeScript = typeof import("typescript") & {
    sys: System;
    getNewLineCharacter(options: CompilerOptions | PrinterOptions, getNewLine?: () => string): string;
};
export interface TypeScriptHost extends FormatDiagnosticsHost {
    ts: TypeScript;
}
export interface TsConfigJson {
    extends?: string;
    files?: string[];
    include?: string[];
    exclude?: string[];
    compilerOptions?: CompilerOptions;
}
export declare function findTsConfigFile(ts: TypeScript, currentDirectory: string, configName?: string): string;
export declare function readTsConfigFile(host: TypeScriptHost, configPath: string): TsConfigJson;
export declare function parseJsonConfigFileContent(host: TypeScriptHost, json: TsConfigJson): ParsedCommandLine;
export declare function createTypeScriptHost(ts: TypeScript, options?: CompilerOptions): TypeScriptHost;
export declare function reportDiagnostic(host: TypeScriptHost, diagnostics: Diagnostic[]): void;
//# sourceMappingURL=ts-utils.d.ts.map